Ruby - Bug #20307

"Hash#update' from compare_by_identity hash can have unfrozen string keys

02/27/2024 03:33 AM - nobu (Nobuyoshi Nakada)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v:

Backport:

3.0: REQUIRED, 3.1: REQUIRED, 3.2:
DONE, 3.3: DONE

Description
| don't think this behavior is expected.

i = Hash.new.compare_by_identity

k = "a"

i[k] =0

h = {}.update (1)

p h.compare_by_identity? # => false
P h[llallJ # => 0
k.upcase!

# "k’ is still in “h°

p h.keys.include? (k) # => true

# but not found.

p((h.fetch (k) rescue $!)) # => #<KeyError: key not found:

h["A"J = 1
ph # => {"A"=>0, "A"=>1}

| expect h to still have "a"=>0 entry.

LY UBS

Associated revisions

Revision f36a71e26995b69ff72bc132bbcf40ad89571414 - 03/14/2024 08:49 AM - nobu (Nobuyoshi Nakada)

[Bug #20307] Fix Hash#update to make frozen copy of string keys

Revision f36a71e26995b69ff72bc132bbcf40ad89571414 - 03/14/2024 08:49 AM - nobu (Nobuyoshi Nakada)

[Bug #20307] Fix Hash#update to make frozen copy of string keys

Revision f36a71e2 - 03/14/2024 08:49 AM - nobu (Nobuyoshi Nakada)
[Bug #20307] Fix Hash#update to make frozen copy of string keys

Revision 917{3e5d22b3364002eb1fdc2f94b35ff76f6a73 - 05/28/2024 10:17 PM - kOkubun (Takashi Kokubun)
merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

[Bug #20307] Fix 'Hash#update® to make frozen copy of string keys

Revision 917f3e5d22b3364002eb1fdc2f94b35ff76f6a73 - 05/28/2024 10:17 PM - kOkubun (Takashi Kokubun)
merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

[Bug #20307] Fix "“Hash#update® to make frozen copy of string keys

Revision 917{3e5d - 05/28/2024 10:17 PM - kOkubun (Takashi Kokubun)

merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

[Bug #20307] Fix "Hash#update® to make frozen copy of string keys

Revision 90a44bcd39c569d851f73d167955c83f3ff2384f - 07/13/2024 06:43 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

06/26/2025

1/3




[Bug #20307] Fix "Hash#update' to make frozen copy of string keys

Revision 90a44bcd39¢569d851173d167955¢c83f3ff2384f - 07/13/2024 06:43 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

[Bug #20307] Fix "“Hash#update  to make frozen copy of string keys

Revision 90a44bcd - 07/13/2024 06:43 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

[Bug #20307] Fix "Hash#update® to make frozen copy of string keys

History

#1 - 02/27/2024 03:54 AM - nobu (Nobuyoshi Nakada)

- Description updated

#2 - 02/27/2024 03:56 AM - nobu (Nobuyoshi Nakada)

- Description updated

#3 - 02/27/2024 04:01 AM - nobu (Nobuyoshi Nakada)

- Description updated

#4 - 02/27/2024 04:04 AM - nobu (Nobuyoshi Nakada)

- Description updated

#5 - 02/27/2024 04:46 AM - nobu (Nobuyoshi Nakada)

- Description updated

https://github.com/ruby/ruby/pull/10099

#6 - 03/03/2024 03:17 PM - Dan0042 (Daniel DeLorme)

After the code above, we can do

h.rehash
P h #=> (WAM=>11)

When a key is clobbered like that due to a rehash, maybe there should be a warning or an error? It seems to me a pretty clear symptom of a bug,
either in the ruby code or in the interpreter itself.

#7 - 03/03/2024 04:15 PM - byroot (Jean Boussier)
| don't understand the bug report nor the patch.
If you make a frozen copy of the provided key, you change the key. e.g.

cache = {}.compare_by_indentity
key = Random.bytes (5)

cachelkey] =1
p cachelkey]

I'd expect cache[key] to return 1, with what | understand of your patch, it wouldn't anymore.

Mutable hash keys aren't a new thing, it's only that regular hash have this special behavior for strings to keep a frozen copy of the string key, but they
don't do that for any other type.

| don't see why identity hashes would need to copy this behavior.

#8 - 03/03/2024 04:18 PM - byroot (Jean Boussier)

ignore me, | misunderstood the reproduction script. h is not compared by identity.

#9 - 03/14/2024 08:49 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed
https://github.com/ruby/ruby/pull/10099

Applied in changeset git|f36a71e26995b69ff72bc132bbcf40ad89571414.

[Bug #20307] Fix Hash#update to make frozen copy of string keys
#10 - 05/28/2024 11:43 PM - kOkubun (Takashi Kokubun)

- Backport changed from 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED to 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED,
3.3: DONE

ruby_3_3 917{3e5d22b3364002eb1fdc2f94b35ff76f6a73 merged revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414.

#11 - 07/13/2024 07:35 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 3.0: REQUIRED, 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE to 3.0: REQUIRED, 3.1: REQUIRED, 3.2: DONE, 3.3: DONE

ruby_3_2 90a44bcd39c569d851f73d167955¢83f3ff2384f merged revision(s) {36a71e26995b69ff72bc132bbcf40ad89571414.
